{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.ComputeOptimizer.Types.JobStatus
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.ComputeOptimizer.Types.JobStatus
  ( JobStatus
      ( ..,
        JobStatus_Complete,
        JobStatus_Failed,
        JobStatus_InProgress,
        JobStatus_Queued
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

newtype JobStatus = JobStatus'
  { fromJobStatus ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern JobStatus_Complete :: JobStatus
pattern JobStatus_Complete = JobStatus' "Complete"

pattern JobStatus_Failed :: JobStatus
pattern JobStatus_Failed = JobStatus' "Failed"

pattern JobStatus_InProgress :: JobStatus
pattern JobStatus_InProgress = JobStatus' "InProgress"

pattern JobStatus_Queued :: JobStatus
pattern JobStatus_Queued = JobStatus' "Queued"

{-# COMPLETE
  JobStatus_Complete,
  JobStatus_Failed,
  JobStatus_InProgress,
  JobStatus_Queued,
  JobStatus'
  #-}
